Attribute VB_Name = "Position"
Option Explicit

Global giSaveSettings As Integer


Sub gCenterDialogPosition(WndName As Form)

  If (WndName.Height > frmMain.Height) Or (WndName.Width > frmMain.Width) Then
    WndName.TOP = (Screen.Height - WndName.Height) \ 2
    WndName.Left = (Screen.Width - WndName.Width) \ 2
  Else
    WndName.TOP = frmMain.TOP + ((frmMain.Height - WndName.Height) \ 2)
    WndName.Left = frmMain.Left + ((frmMain.Width - WndName.Width) \ 2)
  End If

End Sub

Function gGetValue(sKey$, sKeyValue$) As String
Dim lReturn As Long
Dim sClass As String
Dim lDisposition As Long
Dim Security As SECURITY_ATTRIBUTES
Dim sValue As String
Dim hWndQue As Long
Dim hWnd As Long
Dim lLength As Long

  'Create or Open Que Registry entry for local machine
  sClass = Space$(255)
  lReturn = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "QUE", 0&, sClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWndQue, lDisposition)

  sClass = Space$(255)
  lReturn = RegCreateKeyEx(hWndQue, sKey, 0&, sClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWnd, lDisposition)
  
  lLength = 255
  sValue = Space$(lLength)
  lReturn = RegQueryValueEx(hWnd, sKeyValue, 0&, REG_SZ, sValue, lLength)

  'Close open keys
  lReturn = RegCloseKey(hWndQue)
  lReturn = RegCloseKey(hWnd)

  sValue = Trim$(sValue)
  gGetValue = Mid$(sValue, 1, Len(sValue) - 1)
  
End Function


Sub gGetSettings()

  giSaveSettings = Val(gGetValue("Preferences", "SaveSettings"))

  frmMain!mnuOptionsSaveSettings.Checked = giSaveSettings

End Sub

Sub gSaveChildWindowPosition(frmName As Form, sFormTag$)
Dim sWindowState As String
Dim sTopPosition As String
Dim sLeftPosition As String
Dim sFormWidth As String
Dim sFormHeight As String

  If giSaveSettings Then
    sWindowState = Trim$(Str$(frmName.WindowState))
    Call gSetValue(sFormTag, "WindowState", sWindowState)
    sTopPosition = Trim$(Str$(frmName.TOP))
    Call gSetValue(sFormTag, "Top", sTopPosition)
    sLeftPosition = Trim$(Str$(frmName.Left))
    Call gSetValue(sFormTag, "Left", sLeftPosition)
    sFormWidth = Trim$(Str$(frmName.Width))
    Call gSetValue(sFormTag, "Width", sFormWidth)
    sFormHeight = Trim$(Str$(frmName.Height))
    Call gSetValue(sFormTag, "Height", sFormHeight)
  End If

End Sub

Sub gSaveMainFormPosition(frmName As Form)
Dim sWindowState As String
Dim sTopPosition As String
Dim sLeftPosition As String
Dim sFormWidth As String
Dim sFormHeight As String

  If giSaveSettings Then
    sWindowState = Trim$(Str$(frmName.WindowState))
    Call gSetValue("Main", "WindowState", sWindowState)
    sTopPosition = Trim$(Str$(frmName.TOP))
    Call gSetValue("Main", "Top", sTopPosition)
    sLeftPosition = Trim$(Str$(frmName.Left))
    Call gSetValue("Main", "Left", sLeftPosition)
    sFormWidth = Trim$(Str$(frmName.Width))
    Call gSetValue("Main", "Width", sFormWidth)
    sFormHeight = Trim$(Str$(frmName.Height))
    Call gSetValue("Main", "Height", sFormHeight)
  End If

End Sub

Sub gSetChildWindowPosition(frmName As Form, sFormTag$)
Dim sWindowState As String
Dim sTopPosition As String
Dim sLeftPosition As String
Dim sFormWidth As String
Dim sFormHeight As String

  sWindowState = gGetValue(sFormTag, "WindowState")
  Select Case sWindowState
    Case "0"
      sFormWidth = gGetValue(sFormTag, "Width")
      sFormHeight = gGetValue(sFormTag, "Height")
      If frmName.BorderStyle = vbSizable Then
        sTopPosition = gGetValue(sFormTag, "Top")
        sLeftPosition = gGetValue(sFormTag, "Left")
        frmName.Move Val(sLeftPosition), Val(sTopPosition), Val(sFormWidth), Val(sFormHeight)
      Else
        frmName.Move Val(sLeftPosition), Val(sTopPosition)
      End If
    Case "1"
      frmName.WindowState = vbMinimized
    Case "2"
      frmName.WindowState = vbMaximized
    Case Else
      frmName.Move 0, 0
  End Select
    
End Sub

Sub gSetMainFormPosition(frmName As Form)
Dim sWindowState As String
Dim sTopPosition As String
Dim sLeftPosition As String
Dim sFormWidth As String
Dim sFormHeight As String

  sWindowState = gGetValue("Main", "WindowState")
  Select Case sWindowState
    Case "0"
      sTopPosition = gGetValue("Main", "Top")
      sLeftPosition = gGetValue("Main", "Left")
      sFormWidth = gGetValue("Main", "Width")
      sFormHeight = gGetValue("Main", "Height")
      frmName.Move Val(sLeftPosition), Val(sTopPosition), Val(sFormWidth), Val(sFormHeight)
    Case "1"
      frmName.WindowState = vbMinimized
    Case "2"
      frmName.WindowState = vbMaximized
    Case Else
      frmName.Width = 640 * Screen.TwipsPerPixelX
      frmName.Height = 480 * Screen.TwipsPerPixelY
      
      If frmName.Width + 100 > Screen.Width Then
        frmName.WindowState = vbMaximized
      Else
        frmName.TOP = (Screen.Height - frmName.Height) \ 2
        frmName.Left = (Screen.Width - frmName.Width) \ 2
      End If
  End Select

End Sub

Sub gSetValue(sKey$, sKeyValue$, sNewValue$)
Dim lReturn As Long
Dim hWndQue As Long
Dim hWnd As Long
Dim sClass As String
Dim Security As SECURITY_ATTRIBUTES
Dim lDisposition As Long

  'Create or Open Que Registry entry for local machine
  sClass = Space$(255)
  lReturn = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "QUE", 0&, sClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWndQue, lDisposition)

  sClass = Space$(255)
  lReturn = RegCreateKeyEx(hWndQue, sKey, 0&, sClass, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, Security, hWnd, lDisposition)

  'Save Value in the registry
  lReturn = RegSetValueEx(hWnd, sKeyValue, 0&, REG_SZ, sNewValue, Len(sNewValue))

  'Close open keys
  lReturn = RegCloseKey(hWndQue)
  lReturn = RegCloseKey(hWnd)
  
End Sub


